require 'net/http'
require 'uri'

Experiment.name = "nhtest"
Experiment.project = "nhtest"

defProperty('rate', 300, 'Bits per second sent from sender')
defProperty('packetSize', 256, 'Size of packets sent from sender')

defNodes('ap1', [4,5]) {|node|
  node.prototype("test:proto:receiver" , {
    'protocol' => 'udp'
  })
  node.net.w0.mode = "master"
  node.net.w0.essid = "group1"
  node.net.w0.type = 'a'
  node.net.w0.channel = "36"
  node.net.w0.ip = "%192.168.%x.%y"
}

defNodes('ap2', [4,10]) {|node|
  node.prototype("test:proto:receiver" , {
    'protocol' => 'udp'
  })
  node.net.w0.mode = "master"
  node.net.w0.essid = "group2"
  node.net.w0.type = 'a'
  node.net.w0.channel = "40"
  node.net.w0.ip = "%192.168.%x.%y"
}

defNodes('ap3', [4,15]) {|node|
  node.prototype("test:proto:receiver" , {
    'protocol' => 'udp'
  })
  node.net.w0.mode = "master"
  node.net.w0.essid = "group3"
  node.net.w0.type = 'a'
  node.net.w0.channel = "44"
  node.net.w0.ip = "%192.168.%x.%y"
}

defNodes('ap4', [5,7]) {|node|
  node.prototype("test:proto:receiver" , {
    'protocol' => 'udp'
  })
  node.net.w0.mode = "master"
  node.net.w0.essid = "group4"
  node.net.w0.type = 'a'
  node.net.w0.channel = "48"
  node.net.w0.ip = "%192.168.%x.%y"
}

defNodes('ap5', [5,11]) {|node|
  node.prototype("test:proto:receiver" , {
    'protocol' => 'udp'
  })
  node.net.w0.mode = "master"
  node.net.w0.essid = "group5"
  node.net.w0.type = 'a'
  node.net.w0.channel = "52"
  node.net.w0.ip = "%192.168.%x.%y"
}

defNodes('ap6', [5,12]) {|node|
  node.prototype("test:proto:receiver" , {
    'protocol' => 'udp'
  })
  node.net.w0.mode = "master"
  node.net.w0.essid = "group6"
  node.net.w0.type = 'a'
  node.net.w0.channel = "56"
  node.net.w0.ip = "%192.168.%x.%y"
}

defNodes('ap7', [5,15]) {|node|
  node.prototype("test:proto:receiver" , {
    'protocol' => 'udp'
  })
  node.net.w0.mode = "master"
  node.net.w0.essid = "group7"
  node.net.w0.type = 'a'
  node.net.w0.channel = "60"
  node.net.w0.ip = "%192.168.%x.%y"
}

defNodes('ap8', [5,18]) {|node|
  node.prototype("test:proto:receiver" , {
    'protocol' => 'udp'
  })
  node.net.w0.mode = "master"
  node.net.w0.essid = "group8"
  node.net.w0.type = 'a'
  node.net.w0.channel = "64"
  node.net.w0.ip = "%192.168.%x.%y"
}

defNodes('ap9', [6,5]) {|node|
  node.prototype("test:proto:receiver" , {
    'protocol' => 'udp'
  })
  node.net.w0.mode = "master"
  node.net.w0.essid = "group9"
  node.net.w0.type = 'a'
  node.net.w0.channel = "149"
  node.net.w0.ip = "%192.168.%x.%y"
}

defNodes('ap10', [6,7]) {|node|
  node.prototype("test:proto:receiver" , {
    'protocol' => 'udp'
  })
  node.net.w0.mode = "master"
  node.net.w0.essid = "group10"
  node.net.w0.type = 'a'
  node.net.w0.channel = "153"
  node.net.w0.ip = "%192.168.%x.%y"
}

defNodes('sender1', [[4,4],[4,7],[4,9],[4,12],[4,14],[4,18],[6,6],[6,8],[6,10]]) {|node|
  node.prototype("test:proto:sender", {
    'destinationHost' => '192.168.4.5',
    'packetSize' => 1024,
    'rate' => 300,
    'protocol' => 'udp'    
  })
  node.net.w0.mode = "managed"
  node.net.w0.essid = "group1"
  node.net.w0.type = 'a'
  node.net.w0.ip = "%192.168.%x.%y"
}

defNodes('sender2', [[6,13],[6,15],[6,18],[7,4],[7,6],[7,8],[7,10],[7,11],[7,13]]) {|node|
  node.prototype("test:proto:sender", {
    'destinationHost' => '192.168.4.10',
    'packetSize' => 1024,
    'rate' => 300,
    'protocol' => 'udp'    
  })
  node.net.w0.mode = "managed"
  node.net.w0.essid = "group2"
  node.net.w0.type = 'a'
  node.net.w0.ip = "%192.168.%x.%y"
}

defNodes('sender3', [[7,14],[7,17],[8,9],[8,15],[8,17],[9,6],[9,8],[10,4],[10,6]]) {|node|
  node.prototype("test:proto:sender", {
    'destinationHost' => '192.168.4.15',
    'packetSize' => 1024,
    'rate' => 300,
    'protocol' => 'udp'    
  })
  node.net.w0.mode = "managed"
  node.net.w0.essid = "group3"
  node.net.w0.type = 'a'
  node.net.w0.ip = "%192.168.%x.%y"
}

defNodes('sender4', [[10,8],[10,11],[10,16],[13,5],[13,7],[13,10],[13,11],[13,14],[13,16]]) {|node|
  node.prototype("test:proto:sender", {
    'destinationHost' => '192.168.5.7',
    'packetSize' => 1024,
    'rate' => 300,
    'protocol' => 'udp'    
  })
  node.net.w0.mode = "managed"
  node.net.w0.essid = "group4"
  node.net.w0.type = 'a'
  node.net.w0.ip = "%192.168.%x.%y"
}

defNodes('sender5', [[13,17],[14,4],[14,6],[14,8],[14,9],[14,14],[14,17],[14,18],[15,4]]) {|node|
  node.prototype("test:proto:sender", {
    'destinationHost' => '192.168.5.11',
    'packetSize' => 1024,
    'rate' => 300,
    'protocol' => 'udp'    
  })
  node.net.w0.mode = "managed"
  node.net.w0.essid = "group5"
  node.net.w0.type = 'a'
  node.net.w0.ip = "%192.168.%x.%y"
}

defNodes('sender6', [[15,6],[15,9],[15,10],[15,13],[15,17],[5,16],[5,17],[8,4],[8,5]]) {|node|
  node.prototype("test:proto:sender", {
    'destinationHost' => '192.168.5.12',
    'packetSize' => 1024,
    'rate' => 300,
    'protocol' => 'udp'    
  })
  node.net.w0.mode = "managed"
  node.net.w0.essid = "group6"
  node.net.w0.type = 'a'
  node.net.w0.ip = "%192.168.%x.%y"
}

defNodes('sender7', [[7,9],[8,11],[8,12],[7,12],[7,15],[7,18],[8,8],[8,16],[8,18]]) {|node|
  node.prototype("test:proto:sender", {
    'destinationHost' => '192.168.5.15',
    'packetSize' => 1024,
    'rate' => 300,
    'protocol' => 'udp'    
  })
  node.net.w0.mode = "managed"
  node.net.w0.essid = "group7"
  node.net.w0.type = 'a'
  node.net.w0.ip = "%192.168.%x.%y"
}

defNodes('sender8', [[10,7],[9,9],[11,4],[11,6],[11,7],[9,12],[11,16],[12,6],[13,4]]) {|node|
  node.prototype("test:proto:sender", {
    'destinationHost' => '192.168.5.18',
    'packetSize' => 1024,
    'rate' => 300,
    'protocol' => 'udp'    
  })
  node.net.w0.mode = "managed"
  node.net.w0.essid = "group8"
  node.net.w0.type = 'a'
  node.net.w0.ip = "%192.168.%x.%y"
}

defNodes('sender9', [[13,8],[13,13],[12,14],[13,15],[13,18],[14,5],[13,6],[12,8],[14,10]]) {|node|
  node.prototype("test:proto:sender", {
    'destinationHost' => '192.168.6.5',
    'packetSize' => 1024,
    'rate' => 300,
    'protocol' => 'udp'    
  })
  node.net.w0.mode = "managed"
  node.net.w0.essid = "group9"
  node.net.w0.type = 'a'
  node.net.w0.ip = "%192.168.%x.%y"
}

defNodes('sender10', [[15,14],[14,16],[14,15],[16,4],[15,5],[15,8],[15,11],[16,12],[15,16]]) {|node|
  node.prototype("test:proto:sender", {
    'destinationHost' => '192.168.6.7',
    'packetSize' => 1024,
    'rate' => 300,
    'protocol' => 'udp'    
  })
  node.net.w0.mode = "managed"
  node.net.w0.essid = "group10"
  node.net.w0.type = 'a'
  node.net.w0.ip = "%192.168.%x.%y"
}

whenAllInstalled() {|node|
  # Wait for associations to complete (Replace with more clever ssh-based mechanism).
  wait 30 

  allNodes.startApplications
  wait 120

  Experiment.done
}

